Форум программистов, компьютерный форум CyberForum.ru
Наши страницы

С++ для начинающих

Войти
Регистрация
Восстановить пароль
 
Рейтинг: Рейтинг темы: голосов - 38, средняя оценка - 4.63
dikanev
21 / 21 / 1
Регистрация: 28.05.2010
Сообщений: 67
#1

Про наследование от exception - C++

22.11.2010, 21:11. Просмотров 5281. Ответов 13
Метки нет (Все метки)

Есть пример наследования класса для создания собственных исключений:
C++
1
2
3
4
5
6
class MyException: public std::exception {
    virtual const char* what() const throw()
    {
        return "My exception happened";
    }
};
Подскажите, а что означает "const throw()" после заголовка метода?
0
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
22.11.2010, 21:11
Здравствуйте! Я подобрал для вас темы с ответами на вопрос Про наследование от exception (C++):

Наследование класса Exception - C++
Доброе время суток, уважаемые профи, и знатоки! У меня появилась очень серьезная проблема, суть которой заключается в наследовании класа...

Const throw(), наследование от класса exception - C++
В принципе, проблема решена, но хочу разобраться. Код в MSVS: #include <iostream> #include <exception> using namespace std; ...

Создание своего класса исключений, наследование std::exception - C++
хотел создать свой класс исключений пронаследовав от std::exception, но немного запутался в конструкторах... конструктор же не наследуется,...

Объясните про наследование - C++
class A { protected: int n; // закрыты для A, но доступны для B public: virtual void func(void) = 0; }; class B: public...

Про ромбовидное наследование - C++
Доброе время форумчане! Имеем 3 класс! class A { }; class b { }; class c {

Вопрос про наследование. - C++
Добрый день всем! Возможно ли создать производный класс в который будут помещены 2 объекта базового класса с возможностью...

Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
22.11.2010, 23:47 #2
Спецификатор "const" означает, что функция не модифицирует объект, а "throw" — что функция может кинуть исключение.

Добавлено через 8 минут
Вернее, в данном случае, поскольку внутри скобок после "throw" ничего нет, то гарантируется бессбойность. А если бы там стоял какой-то тип, то это бы говорило о возможности кинуть исключение этого типа.
2
st_dent
64 / 64 / 3
Регистрация: 05.07.2010
Сообщений: 219
22.11.2010, 23:48 #3
Цитата Сообщение от volovzi Посмотреть сообщение
А если бы там стоял какой-то тип, то это бы говорило о возможности кинуть исключение этого типа.
А пример не приведете?
0
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
22.11.2010, 23:51 #4
Боюсь соврать, потому что исключениями почти не пользуюсь .
0
ForEveR
В астрале
Эксперт С++
7972 / 4734 / 321
Регистрация: 24.06.2010
Сообщений: 10,541
Завершенные тесты: 3
22.11.2010, 23:57 #5
Лучший ответ Сообщение было отмечено автором темы, экспертом или модератором как ответ
Пример. Исключения кидаются, НО пишется ворнинг, что функция не должна бы кидать исключения.

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
#include <iostream>
 
void foo(int i) throw()
{
    if(i==0)
        throw 0;
    else
        throw "Hello";
}
 
int main()
{
    try
    {
        foo(0);
    }
    catch(...)
    {
        std::cout<<"Catch exception\n";
    }
    return 0;
}
3
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:05 #6
Лучший ответ Сообщение было отмечено автором темы, экспертом или модератором как ответ
Позволю себе немного упростить предыдущий пример:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
#include <iostream>
 
void foo () throw () {
    throw std::string("Исключение");
}
 
int main () {
    try {
        foo();
    } catch (std::string & exception) {
        std::cout << exception;
        }
        
    return 0;
}
Если убрать спецификатор "throw ()" из описания функции, то строка напечатается, а если оставить, то должна быть ошибка времени выполнения.
3
st_dent
64 / 64 / 3
Регистрация: 05.07.2010
Сообщений: 219
23.11.2010, 00:08 #7
Цитата Сообщение от ForEveR Посмотреть сообщение
Пример. Исключения кидаются, НО пишется ворнинг, что функция не должна бы кидать исключения.
Все-таки непонятно зачем тут throw()
C++
1
void foo () throw ()
вот так результат тот же самый:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
#include <iostream>
 
void foo(int i) 
{
        if(i==0)
                throw 0;
        else
                throw "Hello";
}
 
 
[b]volovzi[/b], выше уже ответил
 
int main()
{
        try
        {
                foo(1);
        }
        catch(...)
        {
                std::cout<<"Catch exception\n";
        }
        return 0;
}
volovzi, выше уже ответил
0
ForEveR
В астрале
Эксперт С++
7972 / 4734 / 321
Регистрация: 24.06.2010
Сообщений: 10,541
Завершенные тесты: 3
23.11.2010, 00:11 #8
volovzi, Не согласен. Ошибка выполнения не прошла даже с throw(). Возможно, MSVS опять что-то намутило со стандартом...
0
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:15 #9
Я отвечаю только за gcc и юникс .
Вот что мне сообщают:
Код
terminate called after throwing an instance of 'std::string'
Program received signal:  “SIGABRT”.
1
ForEveR
В астрале
Эксперт С++
7972 / 4734 / 321
Регистрация: 24.06.2010
Сообщений: 10,541
Завершенные тесты: 3
23.11.2010, 00:16 #10
volovzi, Ну да... MSVS как всегда...
У меня не вылетает даже так.

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
#include <iostream>
#include <string>
 
__declspec(nothrow) void foo () {
        throw std::string("Исключение");
}
 
int main () {
        try {
                foo();
        } catch (std::string & exception) {
                std::cout << exception;
        }
            
        return 0;
}
0
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:55 #11
ForEveR, и вообще ничего не говорит? Странно.
0
ForEveR
В астрале
Эксперт С++
7972 / 4734 / 321
Регистрация: 24.06.2010
Сообщений: 10,541
Завершенные тесты: 3
23.11.2010, 00:58 #12
volovzi, Более того. Путем тестов было выяснено, что MSVS редко реагирует на throw.

На gcc ведь будет рантайм не так-ли?

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
#include <iostream>
 
void foo() throw (int)
{
    throw "exc";
}
 
int main()
{
    try
    {
        foo();
    }
    catch(...)
    {
        std::cout<<"Exc\n";
    }
    return 0;
}
0
volovzi
267 / 169 / 8
Регистрация: 14.03.2010
Сообщений: 501
23.11.2010, 00:59 #13
Угу:
Код
terminate called after throwing an instance of 'char*'
Program received signal:  “SIGABRT”.
0
ForEveR
В астрале
Эксперт С++
7972 / 4734 / 321
Регистрация: 24.06.2010
Сообщений: 10,541
Завершенные тесты: 3
23.11.2010, 01:01 #14
volovzi, ну вот. а в студии спокойно печатает сообщение.
0
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
23.11.2010, 01:01
Привет! Вот еще темы с ответами:

Небольшой вопрос про наследование. - C++
Как понять Circle (int x, int y, int r, TColor p, TColor b) : cx (x), cy (y), rad (r), Shape (p, b) {} строчку понял что это...

Глупый вопрос про наследование - C++
Вот фрагмент кода, реального: class CListviewParamPrimary : public CListviewParamFloats { private: /** * @brief Возвращает...

подскажите как првильно написать программу про наследование классов - C++
подскажите как првильно написать задачу про наследование классов вот надо написать задачу про кошку чтобы 1 пророда-сиамская ...

First chance exception at $77ADB09E. Exception class EAccessViolation with message 'Access Violation'. Process - C++
Объясните в каких случаях возникает эта ошибка, из-за чего? Как справиться с этой ошибкой? Только плиз на примере и доступными словами, т....


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
Yandex
Объявления
23.11.2010, 01:01
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2017, vBulletin Solutions, Inc.
Рейтинг@Mail.ru